/*
 * log.h
 *
 *  Created at: 21.02.2010
 *      Author: Chebotarev Roman
 */

#ifndef LOG_H_
#define LOG_H_

#define LOG_DEBUG_FLAG	0x01
#define	LOG_STDOUT_FLAG	0x02

typedef enum log_levels
{
	CLOG,	/* Critical		*/
	ELOG,	/* Error		*/
	WLOG,	/* Warning		*/
	ILOG,	/* Information	*/
	NLOG,	/* Normal		*/
	DLOG	/* Debug		*/
}LLEVEL;

inline int log_init(const char * file_name, uint32_t flags, pid_t uid);
inline int log_close(void);
int log_wr(LLEVEL level, const char * fmt, ...);
inline int log_fileno(void);
inline void log_reopen(void);

#endif /* LOG_H_ */
